/*
 * rproto.h -- prototypes for run-time functions.
 */

#ifdef PreProcess
/* undefine(`shift') undefine(`len') undefine(`syscmd') undefine(`index') */
#endif					/* PreProcess */

int	bfunc		Params((noargs));
long	ckadd		Params((long i, long j));
long	ckmul		Params((long i, long j));
long	cksub		Params((long i, long j));
int	coswitch	Params((word *old, word *new, int first));
int	dup2		Params((int h1, int h2));
char	*ecvt		Params((double value, int count, int *dec, int* sign));
int	getimage	Params((dptr dp1, dptr dp2));
int	inp		Params((unsigned int port));

#if IntBits == 16
novalue	llqsort		Params((char *base, int nel, int width, int (*cmp)()));
#endif					/* IntBits == 16 */

int	outp		Params((unsigned int port, int byte));
int	printable	Params((int c));

#define Fargs dptr cargp

#ifdef PreProcess
/* define(FncDef,int X$1 	Params((Fargs));) */
/* define(FncDefV,int X$1 	Params((int nargs,Fargs));) */
/* include(../h/fdefs.h) /* */
/* undefine(`FncDef') */
/* undefine(`FncDefV') */
/* */
/* define(OpDef,int O$1 	Params((Fargs));) */
/* include(../h/odefs.h) /* */
/* undefine(`OpDef') */
/* */
#else					/* PreProcess */
#define FncDef(p,n) int Cat(X,p) 	Params((Fargs));
#define FncDefV(p) int Cat(X,p) 	Params((int nargs,Fargs));
#include "../h/fdefs.h"
#undef FncDef
#undef FncDefV
#define OpDef(p,n,s) int Cat(O,p) 	Params((Fargs));
#include "../h/odefs.h"
#undef OpDef
#endif					/* PreProcess */

novalue	addmem			Params((struct b_set *ps,struct b_selem *pe,
				   dptr pl));
novalue	adjust			Params((char *source,char *dest));
struct	astkblk *alcactiv	Params((noargs));
struct	b_coexpr *alccoexp	Params((noargs));
struct	b_cset *alccset		Params((noargs));
struct	b_external *alcextrnl	Params((int n));
struct	b_file *alcfile		Params((FILE *fd,int status,dptr name));
struct	b_list *alclist		Params((uword size));
struct	b_lelem *alclstb	Params((uword nslots,uword first,uword nused));
struct	b_real *alcreal		Params((double val));
struct	b_record *alcrecd	Params((int nflds,dptr recptr));
struct	b_refresh *alcrefresh	Params((word *entryx,int na,int nl));
struct	b_selem *alcselem	Params((dptr mbr,word hn));
struct	b_set *alcset		Params((noargs));
char	*alcstr			Params((char *s,word slen));
struct	b_tvsubs *alcsubs	Params((word len,word pos,dptr var));
struct	b_table *alctable	Params((dptr def));
struct	b_telem *alctelem	Params((noargs));
struct	b_tvtbl *alctvtbl	Params((dptr tbl,dptr ref,word hashnum));
int	anycmp			Params((dptr dp1,dptr dp2));
novalue	atrace			Params((dptr sptr));
int	blkreq			Params((uword bytes));
int	Obscan			Params((int nargs,Fargs));
novalue	c_exit			Params((int i));
novalue	coacttrace		Params((struct b_coexpr *ccp,
				   struct b_coexpr *ncp));
novalue	cofailtrace		Params((struct b_coexpr *ccp,
				   struct b_coexpr *ncp));
novalue	cofree			Params((noargs));
novalue	collect			Params((int region));
novalue	compact			Params((char *source));
novalue	corettrace		Params((struct b_coexpr *ccp,
				   struct b_coexpr *ncp));
int	cplist			Params((dptr dp1,dptr dp2,word i,word j));
int	Ocreate			Params((word *entryp,Fargs));
int	csetcmp			Params((unsigned int *cs1,unsigned int *cs2));
novalue	ctrace			Params((dptr sptr,int nargs,dptr arg));
int	cvcset			Params((dptr dp,int * *cs,int *csbuf));
int	cvint			Params((dptr dp,long *i));
int	cvnum			Params((dptr dp,union numeric *result));
word	cvpos			Params((long pos,long len));
int	cvreal			Params((dptr dp,double *r));
int	cvstr			Params((dptr dp,char *sbuf));
novalue	datainit			Params((noargs));
int	defcset			Params((dptr dp,int * *cp,int *buf,int *def));
int	deffile			Params((dptr dp,dptr def));
int	defint			Params((dptr dp,long *lp,word def));
int	defshort		Params((dptr dp,int def));
int	defstr			Params((dptr dp,char *buf,dptr def));
int	deref			Params((dptr dp));
int	doasgn			Params((dptr dp1,dptr dp2));
int	doimage			Params((int c,int q));
novalue	env_int			Params((char *name,word *variable,int non_neg,
				   uword limit));
int	envset			Params((noargs));
int	equiv			Params((dptr dp1,dptr dp2));
int	err			Params((noargs));
novalue	error			Params((char *s));
int	Oescan			Params((int nargs,Fargs));
novalue	fatalerr		Params((int n,dptr v));
int	Ofield			Params((int nargs,Fargs));
char	*findfile		Params((word *ipc));
int	findline		Params((word *ipc));
int	fixtrap			Params((noargs));
int	fpetrap			Params((noargs));
novalue	failtrace		Params((dptr sptr));
int	getstrg			Params((char *buf,int maxi,FILE *fd));
word	hash			Params((dptr dp));
char	*icon_gcvt		Params((double number,int ndigit,char *buf));
novalue	iconhost		Params((char *hostname));
novalue	init			Params((char *name));
novalue	initalloc		Params((word codesize));

int	interp			Params((int fsig,dptr cargp));

int	invoke			Params((int nargs,dptr  *cargp,int *n));
long	ipow			Params((long n1,long n2));
int	Okeywd			Params((int nargs,Fargs));
int	lexcmp			Params((dptr dp1,dptr dp2));
int	Olimit			Params((int nargs,Fargs));
int	Ollist			Params((int nargs,Fargs));
int	locate			Params((struct b_selem *ep,struct b_selem *obj));
word	longread		Params((char *s,int width,long len,FILE *fname));
novalue	markblock		Params((dptr dp));
dptr	memb			Params((struct b_set *ps,dptr x,word hn,
				   int *res));
dptr	memb_tbl		Params((struct b_table *pt,dptr x,word hn,
				   int *res));
pointer	memcpy			Params((char *dest,char *src, int c));
int	mkreal			Params((double r,dptr dp));
int	Omkrec			Params((int nargs,Fargs));
novalue	mksubs			Params((dptr var,dptr val,word i,word j,
				   dptr result));
novalue	mvc			Params((uword n,char *src,char *dest));
int	numcmp			Params((dptr dp1,dptr dp2,dptr dp3));
int	order			Params((dptr dp));
novalue	outimage		Params((FILE *f,dptr dp,int restrict));
struct	b_coexpr *popact	Params((struct b_coexpr *ce));
novalue	postqual		Params((dptr dp));
word	prescan			Params((dptr d));
int	pushact			Params((struct b_coexpr *ce,
				   struct b_coexpr *actvtr));
int	putpos			Params((dptr dp,struct b_tvkywd *bp));
int	putstr			Params((FILE *f,dptr d));
int	putsub			Params((dptr dp,struct b_tvkywd *bp));
int	putint			Params((dptr dp,struct b_tvkywd *bp));
int	qlcmp			Params((dptr  *q1,dptr  *q2));
int	qtos			Params((dptr dp,char *sbuf));
int	resolve			Params((noargs));
int	rtos			Params((double n,dptr dp,char *s));
novalue	rtrace			Params((dptr sptr,dptr rval));
novalue	runerr			Params((int n,dptr v));
novalue	scollect		Params((word extra));
int	segvtrap		Params((noargs));
novalue	stkdump			Params((int));
novalue	strace			Params((dptr sptr,dptr rval));
int	strprc			Params((dptr dp,word n));
int	strreq			Params((uword n));
novalue	sweep			Params((struct b_coexpr *ce));
novalue	syserr			Params((char *s));
struct	b_coexpr *topact	Params((struct b_coexpr *ce));
int	trcmp3			Params((struct dpair *dp1,struct dpair *dp2));
int	trefcmp			Params((dptr d1,dptr d2));
novalue	ttrace			Params((noargs));
int	tvalcmp			Params((dptr d1,dptr d2));
int	tvcmp4			Params((struct dpair *dp1,struct dpair *dp2));
novalue	xdisp			Params((struct pf_marker *fp,dptr dp,int count,
				   FILE *f));
novalue	xtrace			Params((struct b_proc *bp,word nargs,dptr arg,
				   int pline,char *pfile));

#ifdef MemMon

novalue	MMInit			Params((char *name));
novalue	MMTerm			Params((char *part1, char *part2));

novalue	MMAlc			Params((word len, int type));
novalue	MMBGC			Params((int region));
novalue	MMEGC			Params((noargs));
novalue	MMMark			Params((char *block, int type));
novalue	MMStat			Params((char *a, word n, int c));
novalue	MMStr			Params((word slen));
novalue	MMSMark			Params((char *saddr, word slen));
#endif					/* MemMon */


double pow();			/* prototype problem */
