# awk program to preprocess color symbol & label definitions into C

BEGIN		{ n=0; }	# initialize symbol counter
/^#/		{ next; }	# skip comment lines
NF>0 && NF<3	{ print("#error on line",NR": bad label definition:",$0); }
NF>=3		{ s[n]=$1; c[n]=$2; l[n]=$3; n++; }
END {
    printf("/* created mechanically -- DO NOT EDIT */\n\n");
    printf("#ifndef NColors\n");
    for (i = 0; i < n; i++)
	printf("#define %-11s %2d\n",s[i],i);
    printf("#define NColors %d\n",n);
    printf("#endif\t\t\t\t/* NColors */\n\n");
    printf("#ifdef Color\n");
    for (i = 0; i < n; i++)
	printf("Color(%s,%s,%s)\n",s[i],c[i],l[i]);
    printf("#endif\t\t\t\t/* Color */\n");
    }
