#include "preproc.h"

#if PORT
   /* something may be needed */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || HIGHC_386 || MACINTOSH || VM || MVS || VMS
   /* something may be needed */
Deliberate Syntax Error
#endif					/* AMIGA || ATARI_ST || ... */

#if MSDOS
#if MICROSOFT
   /* nothing is needed */
#endif					/* MICROSOFT */
#if TURBO
#include <dir.h>
#define Strng(s) #s
#define StrMBody(m) Strng(m)
#define CBufSz 200
#endif 					/* TURBO */
#endif					/* MSDOS */

#if UNIX
   /* nothing is needed */
#endif					/* UNIX */

/*
 * End of operating-system specific code.
 */

/*
 * Prototypes for static functions.
 */
hidden novalue str_src      Params((char *src_name, char *s, int len));
hidden novalue do_directive Params((char *s));
hidden novalue undef_opt    Params((char *s, int len));
hidden novalue define_opt   Params((char *s, int len, struct token *dflt));
hidden novalue mac_opts     Params((char *opt_lst, char **opt_args));

struct src dummy;

static novalue str_src(src_name, s, len)
char *src_name;
char *s;
int len;
   {
   union src_ref ref;
   int *ip1, *ip2;

   ref.cs = new_cs(src_name, NULL, len + 1);
   push_src(CharSrc, &ref);
   ip1 = ref.cs->char_buf;
   ip2 = ref.cs->line_buf;
   while (len-- > 0) {
     *ip1++ = *s++;
     *ip2++ = 0;
     }
   *ip1 = EOF;
   *ip2 = 0;
   ref.cs->next_char = ref.cs->char_buf;
   ref.cs->last_char = ip1;
   first_char = ref.cs->char_buf;
   next_char = first_char;
   last_char = ref.cs->last_char;
   }

static novalue do_directive(s)
char *s;
   {
   str_src("<initialization>", s, strlen(s));
   while (interp_dir() != NULL)
      ;
   }
   
static novalue undef_opt(s, len)
char *s;
int len;
   {
   struct token *mname;
   int i;

   str_src("<options>", s, len);
   mname = next_tok();
   if (mname == NULL || mname->tok_id != Identifier ||
     next_tok() != NULL) {
      fprintf(stderr, "invalid argument to -U option: ");
      for (i = 0; i < len; ++i)
         putc(s[i], stderr);
      putc('\n', stderr);
      show_usage();
      }
   m_delete(mname);
   }

static novalue define_opt(s, len, dflt)
char *s;
int len;
struct token *dflt;
   {
   struct token *mname;
   struct token *t;
   struct tok_lst *body;
   struct tok_lst **ptlst, **trail_whsp;
   int i;

   str_src("<options>", s, len);
   mname = next_tok();
   if (mname == NULL || mname->tok_id != Identifier) {
      fprintf(stderr, "invalid argument to -D option: ");
      for (i = 0; i < len; ++i)
         putc(s[i], stderr);
      putc('\n', stderr);
      show_usage();
      }
   if (chk_eq_sign()) {
      /*
       * strip leading white space
       */
      t = next_tok();
      if (t != NULL && t->tok_id == WhiteSpace) {
         free_t(t);
         t = next_tok();
         }
            
      body = NULL;
      ptlst = &body;
      trail_whsp = NULL;
      while (t != NULL) {
         t->flag &= ~LineChk;
         (*ptlst) = new_t_lst(t);
         if (t->tok_id == WhiteSpace)
            trail_whsp = ptlst;
         else
            trail_whsp = NULL;
         ptlst = &(*ptlst)->next;
         t = next_tok();
         }
     
         /*
          * strip trailing white space
          */
         if (trail_whsp != NULL) {
            free_t_lst(*trail_whsp);
            *trail_whsp = NULL;
            }
         }
      else {   /* no '=' after the -D */
         if (next_tok() == NULL)
            if (dflt == NULL)
               body = NULL;
            else
               body = new_t_lst(copy_t(dflt));
         else {
            fprintf(stderr, "invalid argument to -D option: ");
            for (i = 0; i < len; ++i)
               putc(s[i], stderr);
            putc('\n', stderr);
            show_usage();
            }
         }

      m_install(mname, NoArgs, 0, NULL, body);
   }

static novalue mac_opts(opt_lst, opt_args)
char *opt_lst;
char **opt_args;
   {
   int i;

/*
 * The following code is operating-system dependent [@p_init.01]. 
 */

#if PORT
   /* something may be needed */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || HIGHC_386 || MACINTOSH || VM || MVS || VMS
   /* something may be needed */
Deliberate Syntax Error
#endif					/* AMIGA || ATARI_ST || ... */

#if MSDOS
#if MICROSOFT
   char *undef_model = "#undef M_I86SM\n#undef M_I86CM\n#undef M_I86MM\n"
       "#undef M_I86LM\n#undef M_I86HM\n";
   char *cl_var;
   
   do_directive("#define MSDOS 1\n");
   do_directive("#define M_I86 1\n");
   do_directive("#define M_I86SM 1\n");
   
   cl_var = getenv("CL");
   if (cl_var != NULL)
      while (*cl_var != '\0') {
         if (*cl_var == '/' || *cl_var == '-') {
            ++cl_var;
            switch (*cl_var) {
               case 'U':
                  ++cl_var;
                  while (*cl_var == ' ' || *cl_var == '\t')
                     ++cl_var;
                  i = 0;
                  while (cl_var[i] != ' ' && cl_var[i] != '\t' &&
                    cl_var[i] != '\0')
                     ++i;
                  undef_opt(cl_var, i);
                  cl_var += i;
                  break;
               case 'u':
                  do_directive("#undef MSDOS\n");
                  do_directive("#undef M_I86\n");
                  do_directive("#undef NO_EXT_KEYS\n");
                  do_directive("#undef _CHAR_UNSIGED\n"); 
                  break;
               case 'D':
                  ++cl_var;
                  while (*cl_var == ' ' || *cl_var == '\t')
                     ++cl_var;
                  i = 0;
                  while (cl_var[i] != ' ' && cl_var[i] != '\t' &&
                    cl_var[i] != '\0')
                     ++i;
                  define_opt(cl_var, i, one_tok);
                  cl_var += i;
                  break;
               case 'A':
                  ++cl_var;
                  switch (*cl_var) {
                     case 'S':
                        do_directive(undef_model);
                        do_directive("#define M_I86SM 1\n");
                        break;
                     case 'C':
                        do_directive(undef_model);
                        do_directive("#define M_I86CM 1\n");
                       break;
                     case 'M':
                        do_directive(undef_model);
                        do_directive("#define M_I86MM 1\n");
                        break;
                     case 'L':
                        do_directive(undef_model);
                        do_directive("#define M_I86LM 1\n");
                        break;
                     case 'H':
                        do_directive(undef_model);
                        do_directive("#define M_I86LM 1\n");
                        do_directive("#define M_I86HM 1\n");
                        break;
                     }
                  break;
               case 'Z':
                  ++cl_var;
                  if (*cl_var == 'a') {
                     do_directive("#undef NO_EXT_KEYS\n");
                     do_directive("#define NO_EXT_KEYS 1\n");
                     }
                  break;
               case 'J':
                   do_directive("#undef _CHAR_UNSIGED\n"); 
                   do_directive("#define _CHAR_UNSIGNED 1\n");
                   break;
               }
            }
         if (*cl_var != '\0')
            ++cl_var;
         }
#endif					/* MICROSOFT */

#if TURBO
   char *undef_models = "#undef __TINY__\n#undef __SMALL__\n#undef __MEDIUM__\n\
#undef __COMPACT__\n#undef __LARGE__\n#undef __HUGE__\n";
   char dir_buf[60];
   char *cfg_fname;
   FILE *cfg_file;
   char cbuf[CBufSz];
   int c;
    
   do_directive("#define __MSDOS__ 1\n");
   do_directive("#define __SMALL__ 1\n");
   do_directive("#define __CDECL__ 1\n");
   sprintf(dir_buf, "#define __TURBOC__ %s\n", StrMBody(__TURBOC__));
   do_directive(dir_buf);
    
   cfg_fname = searchpath("turboc.cfg");
   if (cfg_fname != NULL && (cfg_file = fopen(cfg_fname, "r")) != NULL) {
      c = getc(cfg_file);
      while (c != EOF) {
      	  if (c == '-') {
             c = getc(cfg_file);
             switch (c) {
                case 'U':
                   i = 0;
                   c = getc(cfg_file);
                   while (c != ' ' && c != '\t' && c != '\n' && c != EOF) {
                      if (i >= CBufSz) {
                         cbuf[CBufSz - 1] = '\0';
                         err2("-U argument too big: ", cbuf);
                         }
                      cbuf[i++] = c;
                      c = getc(cfg_file);
                      }
                   undef_opt(cbuf, i);
                   break;
                case 'D':
                   i = 0;
                   c = getc(cfg_file);
                   while (c != ' ' && c != '\t' && c != '\n' && c != EOF) {
                      if (i >= CBufSz) {
                         cbuf[CBufSz - 1] = '\0';
                         err2("-D argument too big: ", cbuf);
                         }
                      cbuf[i++] = c;
                      c = getc(cfg_file);
                      }
                   define_opt(cbuf, i, NULL);
                   break;
                case 'm':
                   switch (c = getc(cfg_file)) {
                      case 't':
                         do_directive(undef_models);
                         do_directive("#define __TINY__ 1\n");
                         break;
                      case 's':
                         do_directive(undef_models);
                         do_directive("#define __SMALL__ 1\n");
                         break;
                      case 'm':
                         do_directive(undef_models);
                         do_directive("#define __MEDIUM__ 1\n");
                         break;
                      case 'c':
                         do_directive(undef_models);
                         do_directive("#define __COMPACT__ 1\n");
                         break;
                      case 'l':
                         do_directive(undef_models);
                         do_directive("#define __LARGE__ 1\n");
                         break;
                      case 'h':
                         do_directive(undef_models);
                         do_directive("#define __HUGE__ 1\n");
                         break;
                      }
                   break;
                case 'p':
                   do_directive("#undef __PASCAL__\n#undef __CDECL__\n");
                   do_directive("#define __PASCAL__ 1\n");
                   break;
                }
             }
          if (c != EOF)
             c = getc(cfg_file);
          }
       fclose(cfg_file);
       }
#endif 					/* TURBO */
#endif					/* MSDOS */

#if UNIX
   do_directive("#define unix 1\n");
#ifdef i286
   do_directive("#define i286 1\n");
#endif
#ifdef i386
   do_directive("#define i386 1\n");
#endif
#ifdef vax
   do_directive("#define vax 1\n");
#endif
#ifdef sun
   do_directive("#define sun 1\n");
#endif
#ifdef mc68000
   do_directive("#define mc68000 1\n");
#endif
#ifdef mc68010
   do_directive("#define mc68010 1\n");
#endif
#ifdef mc68020
   do_directive("#define mc68020 1\n");
#endif
#endif					/* UNIX */

/*
 * End of operating-system specific code.
 */

   /*
    * look for options that affect macro definitions (-U, -D, etc).
    */
   for (i = 0; opt_lst[i] != '\0'; ++i)
      switch(opt_lst[i]) {
         case 'U':
            undef_opt(opt_args[i], strlen(opt_args[i]));
            break;

         case 'D':
            define_opt(opt_args[i], strlen(opt_args[i]), one_tok);
            break;

/*
 * The following code is operating-system dependent [@p_init.02]. Check for
 *  system specific options from command line.
 */

#if PORT
   /* something may be needed */
Deliberate Syntax Error
#endif					/* PORT */

#if AMIGA || ATARI_ST || HIGHC_386 || MACINTOSH || VM || MVS || VMS
   /* something may be needed */
Deliberate Syntax Error
#endif					/* AMIGA || ATARI_ST || ... */

#if MSDOS
#if MICROSOFT
         case 'A':
            switch (*opt_args[i]) {
               case 'S':
                  do_directive(undef_model);
                  do_directive("#define M_I86SM 1\n");
                  break;
               case 'C':
                  do_directive(undef_model);
                  do_directive("#define M_I86CM 1\n");
                  break;
               case 'M':
                  do_directive(undef_model);
                  do_directive("#define M_I86MM 1\n");
                  break;
               case 'L':
                  do_directive(undef_model);
                  do_directive("#define M_I86LM 1\n");
                  break;
               case 'H':
                  do_directive(undef_model);
                  do_directive("#define M_I86LM 1\n");
                  do_directive("#define M_I86HM 1\n");
                  break;
               default:
                  fprintf(stderr, "invalid argument to -A option: %s\n",
                     opt_args[i]);
                  show_usage();
               }
            break;
         case 'Z':
            if (*opt_args[i] == 'a') {
               do_directive("#undef NO_EXT_KEYS\n");
               do_directive("#define NO_EXT_KEYS 1\n");
               }
            else {
               fprintf(stderr, "invalid argument to -Z option: %s\n",
                  opt_args[i]);
               show_usage();
            }
            break;
         case 'J':
             do_directive("#undef _CHAR_UNSIGED\n"); 
             do_directive("#define _CHAR_UNSIGNED 1\n");
             break;
#endif					/* MICROSOFT */

#if TURBO
         case 'm':
            switch (*opt_args[i]) {
               case 't':
                  do_directive(undef_models);
                  do_directive("#define __TINY__ 1\n");
                  break;
               case 's':
                  do_directive(undef_models);
                  do_directive("#define __SMALL__ 1\n");
                  break;
               case 'm':
                  do_directive(undef_models);
                  do_directive("#define __MEDIUM__ 1\n");
                  break;
               case 'c':
                  do_directive(undef_models);
                  do_directive("#define __COMPACT__ 1\n");
                  break;
               case 'l':
                  do_directive(undef_models);
                  do_directive("#define __LARGE__ 1\n");
                  break;
               case 'h':
                  do_directive(undef_models);
                  do_directive("#define __HUGE__ 1\n");
                  break;
               default:
                  fprintf(stderr, "invalid argument to -m option: %s\n",
                     opt_args[i]);
                  show_usage();
               }
            break;
         case 'p':
            do_directive("#undef __PASCAL__\n#undef __CDECL__\n");
            do_directive("#define __PASCAL__ 1\n");
            break;
#endif					/* TURBO */
#endif					/* MSDOS */

#if UNIX
   /* nothing is needed */
#endif					/* UNIX */

/*
 * End of operating-system specific code.
 */
         }
   }

novalue init_preproc(fname, opt_lst, opt_args)
char *fname;
char *opt_lst;
char **opt_args;
   {

   init_str();
   init_tok();
   init_macro();
   init_files(opt_lst, opt_args);
   dummy.flag = DummySrc;
   dummy.ntoks = 0;
   src_stack = &dummy;
   mac_opts(opt_lst, opt_args);
   source(fname);
   }
