#include "preproc.h"

int line_cntrl;

/*
 * output - output preprocessed tokens for the current file.
 */
novalue output(out_file)
FILE *out_file;
   {
   struct token *t, *t1;
   struct token *saved_whsp;
   char *fname;
   char *s;
   int line;
   int nxt_line;
   int trail_nl;  /* flag: trailing character in output is a new-line */
   int  blank_ln;  /* flag: output ends with blank line */

   fname = "";
   line = -1;
   trail_nl = 1;
   blank_ln = 1;
   
   while ((t = preproc()) != NULL) {
      if (t->flag & LineChk) {
         nxt_line = t->line;
         if (fname != t->fname  || line != nxt_line) {
            /*
             * We need a #line directive. Make sure it is preceeded by a
             *  blank line.
             */
            if (!trail_nl) {
               putc('\n', out_file);
               ++line;
               trail_nl = 1;
               }
            if (!blank_ln && (line != nxt_line || fname != t->fname)) {
               putc('\n', out_file);
               ++line;
               blank_ln = 1;
               }
            /*
             * Eliminate extra new-lines before inserting line directive.
             */
            saved_whsp = NULL;
            s = t->image;
            while (t->tok_id == WhiteSpace && (*s == ' ' || *s == '\n' ||
                 *s == '\t')) {
               if (*s == '\n') {
                  free_t(saved_whsp);
                  saved_whsp = NULL;
                  t->image = s + 1;
                  ++t->line;
                  ++nxt_line;
                  }
               ++s;
               if (*s == '\0') {
                  free_t(saved_whsp);
                  t1 = preproc();
                  if (t1 == NULL) {
                     free_t(t);
                     if (!trail_nl)
                        putc('\n', out_file);
                     return;
                     }
                  if (*(t->image) != '\0' && t->line == t1->line &&
                       t->fname == t1->fname)
                     saved_whsp = t;
                  else {
                     free_t(t);
                     saved_whsp = NULL;
                     }
                  t = t1;
                  s = t->image;
                  nxt_line = t->line;
                  }
               }
            if (line_cntrl) {
               if (fname != t->fname  || line > nxt_line ||
                    line + 2 < nxt_line) {
                  fprintf(out_file, "#line %d \"", nxt_line - 1);
                  for (s = t->fname; *s != '\0'; ++s) {
                     if (*s == '"' || *s == '\\')
                        putc('\\',out_file);
                     putc(*s, out_file);
                     }
                  fprintf(out_file, "\"\n\n");
                  trail_nl = 1;
                  blank_ln = 1;
                  }
               else
                  while (line < nxt_line) {
                     putc('\n', out_file);
                     ++line;
                     if (trail_nl)
                        blank_ln = 1;
                     trail_nl = 1;
                     }
               }
            if (saved_whsp != NULL) {
               fprintf(out_file, "%s", saved_whsp->image);
               free_t(saved_whsp);
               if (trail_nl) {
                  blank_ln = 1;
                  trail_nl = 0;
                  }
               }
            line = t->line;
            fname = t->fname;
            }
         }

      if (t->tok_id == WhiteSpace) {
         for (s = t->image; *s != '\0'; ++s) {
            putc(*s, out_file);
            switch (*s) {
               case '\n':
                  if (trail_nl)
                     blank_ln = 1;
                  trail_nl = 1;
                  ++line;
                  break;

               case ' ':
               case '\t':
                  if (trail_nl)
                     blank_ln = 1;
                  trail_nl = 0;
                  break;

               default:
                  trail_nl = 0;
               }
            }
         }
      else {
         switch (t->tok_id) {
            case StrLit:
               fprintf(out_file, "\"%s\"", t->image);
               break;
            case LStrLit:
               fprintf(out_file, "L\"%s\"", t->image);
               break;
            case CharConst:
               fprintf(out_file, "'%s'", t->image);
               break;
            case LCharConst:
               fprintf(out_file, "L'%s'", t->image);
               break;
            default:
               fprintf(out_file, "%s", t->image);
            }
         trail_nl = 0;
         blank_ln = 0;
         }
      free_t(t);
      }
   if (!trail_nl)
      putc('\n', out_file);
   }
