#include "../h/config.h"
#include "pproto.h"
#include "ptoken.h"

/*
 * The following code is operating-system dependent.
 */

#if PORT
   /* may need something */
#endif					/* PORT */

#if AMIGA || ATARI_ST || HIGHC_386 || MACINTOSH || VM || MVS || VMS
   /* may need something */
#endif					/* AMIGA || ATARI_ST || ... */

#if MSDOS
#if MICROSOFT
#include <stdlib.h>
#endif					/* MICROSOFT */
#if TURBO
#include <alloc.h>
#endif					/* TURBO */
#endif					/* MSDOS */

#if UNIX
   /* nothing is needed */
#endif					/* UNIX */

/*
 * End of operating-system specific code.
 */

#define NewStruct(var, type) {\
   if ((var = (struct type *)malloc(sizeof (struct type))) == NULL)\
      err1("out of memory"); }

#define AppChar(sbuf, c) {\
   if ((sbuf).endimage >= (sbuf).end)\
      new_sbuf(&(sbuf));\
   *((sbuf).endimage)++ = (c); }

#define HashSize 37
#define SBufSize 1024
#define CBufSize 256

/*
 * Identification numbers for tokens for which there are no definitions
 *   generated from a C grammar by yacc.
 */
#define WhiteSpace 1001
#define PpNumber   1002
#define PpIf       1003
#define PpElse     1004
#define PpIfdef    1005
#define PpIfndef   1006
#define PpElif     1007
#define PpEndif    1008
#define PpInclude  1009
#define PpDefine   1010
#define PpUndef    1011
#define PpLine     1012
#define PpError    1013
#define PpPragma   1014
#define PpPaste    1015
#define PpDirEnd   1016
#define PpHeader   1017
#define PpBegdef   1018
#define PpEnddef   1019
#define PpNull     1020
#define Invalid    9999

extern char *progname;
extern line_cntrl;

/*
 * whsp_image determines whether the spelling of white space is not retained,
 *   is retained with each comment replaced by a space, or the full spellling
 *   of white space and comments is retained.
 */
#define NoSpelling 0
#define NoComment  1
#define FullImage  2

extern int whsp_image;

extern int max_recurse;
extern struct token *zero_tok;
extern struct token *one_tok;

extern int *first_char;
extern int *next_char;
extern int *last_char;

extern struct src dummy;

extern char *progname;

struct str_buf {
   int size;
   char *strtimage;
   char *endimage;
   char *end;
   struct str_buf *next;
   };

struct rsrvd_wrd {
   char *s;
   int tok_id;
   };

/*
 * token flags:
 */
#define LineChk  0x1   /* A line directive may be needed in the output */
#define NoExpand 0x2   /* Don't macro expand this identifier */

struct token {
   int tok_id;		/* token identifier */
   char *image;		/* string image of token */
   char *fname;
   int line;
   int flag;
   struct token *next;
   };

struct tok_lst {
   struct token *t;
   struct tok_lst *next;
   };

struct id_lst {
   char *id;
   struct id_lst *next;
   };

/*
 * a macro, m, falls into one of several categores:
 *   those with arguments                - m.category = # args >= 0
 *   those with no arguments             - m.category = NoArgs
 *   those that may not be chaged        - m.category = FixedMac
 *   those that require special handling - m.category = SpecMac
 */
#define NoArgs   -1
#define FixedMac -2
#define SpecMac  -3

struct macro {
   char *mname;
   int category;
   int multi_line;
   struct id_lst *prmlst;
   struct tok_lst *body;
   int ref_cnt;
   int recurse;
   struct macro *next;
   };

/*
 * states for recongizing preprocessor directives
 */
#define Reset    1
#define CanStart 2   /* Just saw a new-line, look for a directive */
#define Within   3   /* Next new-line ends directive */

struct char_src {
   FILE *f;               /* file, if the chars come directly from a file */
   char *fname;		  /* name of file */
   int bufsize;		  /* size of character buffer */  
   int *char_buf;         /* pointer to character buffer */
   int *line_buf;	  /* buffer of lines characters come from */
   int *next_char;	  /* next unprocessed character in buffer */
   int *last_char;	  /* last character in buffer */
   int line_adj;	  /* line adjustment caused by #line directive */
   int dir_state;	  /* state w.r.t. recognizing directives */
   struct token *tok_sav; /* used to save token after look ahead */
   struct char_src *next;
   };

struct mac_expand {
   struct macro *m;	      /* the macro being expanded */
   struct tok_lst **args;     /* list of arguments for macro call */
   struct tok_lst **exp_args; /* list of expanded arguments for macro call */
   struct tok_lst *rest_bdy;  /* position within the body of the macro */
   struct mac_expand *next;
   };

struct paste_lsts {
   struct token *trigger;
   struct tok_lst *tlst;
   struct paste_lsts *next;
};

union src_ref {
   struct char_src *cs;      /* source is tokenized characters */
   struct mac_expand *me;    /* source is macro expansion */
   struct tok_lst *tlst;     /* source is token list (a macro argument) */
   struct paste_lsts *plsts; /* source is token lists for token pasting */
   };
   
/*
 * Types of token sources:
 */
#define CharSrc   0     /* tokenized characters */
#define MacExpand 1     /* macro expansion */
#define TokLst    2     /* token list */
#define PasteLsts 4	/* paste last token of 1st list to fisrt of 2nd */
#define DummySrc  5

#define NTokSav  2 

struct src {
   int flag;			/* indicate what kind of source it is */
   struct tok_lst *cond;	/* list of nested conditionals in effect */
   struct token *toks[NTokSav];	/* token push-back stack for preproc() */
   int ntoks;			/* number of tokens on stack */
   struct src *next;		/* link for creating stack */
   union src_ref u;
   };

extern struct src *src_stack;

